/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { HorizontalRangeCategorySeries } from "./HorizontalRangeCategorySeries";
import { DependencyProperty } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { typeCast, runOn, markType, markDep, fromEnum } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { List$1 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_, isInfinity } from "igniteui-angular-core";
import { RangeCategorySeriesView } from "./RangeCategorySeriesView";
/**
 * @hidden
 */
var RangeColumnSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeColumnSeries, _super);
    function RangeColumnSeries() {
        var _this = _super.call(this) || this;
        _this.ab = RangeColumnSeries.$;
        return _this;
    }
    RangeColumnSeries.prototype.bk = function () {
        return new RangeColumnSeries();
    };
    RangeColumnSeries.prototype.get_e1 = function () {
        return true;
    };
    RangeColumnSeries.prototype.get_fm = function () {
        return true;
    };
    RangeColumnSeries.prototype.jn = function () {
        if (!isNaN_(this.jm)) {
            return _super.prototype.jn.call(this);
        }
        return Defaults.h;
    };
    RangeColumnSeries.prototype.ct = function () {
        return new RangeColumnSeriesView(this);
    };
    RangeColumnSeries.prototype.q7 = function (a) {
        _super.prototype.q7.call(this, a);
        this.acc = a;
    };
    RangeColumnSeries.prototype.get_ef = function () {
        return true;
    };
    RangeColumnSeries.prototype.preferredCategoryMode = function (a) {
        return 2;
    };
    RangeColumnSeries.prototype.wx = function (a) {
        if (this.xAxis == null || this.yAxis == null) {
            return Rect.empty;
        }
        var b = this.wh(a);
        var c = this.cw.ca;
        var d = this.cw.b9;
        var e = this.getEffectiveViewport1(this.cw);
        var f = new ScalerParams(0, c, d, this.yAxis.df, e);
        f.b = this.i0();
        var g = this.an(this.y2(), this.y4.h, this.z5(this.cw), this.z6(this.cw), a, true);
        if (g == null) {
            return Rect.empty;
        }
        var h = g[0];
        var i = g[1];
        var j = Math.abs(b.x - h[0]);
        var k = Math.abs(b.x - i[0]);
        var l = this.xAxis.ou(c, d, e);
        if (j < k) {
            var m = h[0] - 0.5 * l;
            var n = h[1];
            var o = h[2];
            return new Rect(0, m, Math.min(n, o), l, Math.max(n, o) - Math.min(n, o));
        }
        else {
            var p = i[0] - 0.5 * l;
            var q = i[1];
            var r = i[2];
            return new Rect(0, p, Math.min(q, r), l, Math.max(q, r) - Math.min(q, r));
        }
    };
    RangeColumnSeries.prototype.gx = function (a, b) {
        if (this.g0(a, b)) {
            return true;
        }
        if (this.xr(a, b)) {
            return true;
        }
        return false;
    };
    RangeColumnSeries.prototype.pb = function (a, b) {
        _super.prototype.pb.call(this, a, b);
        var c = b;
        if (a && c.dl != null) {
            c.dl.count = 0;
        }
    };
    RangeColumnSeries.prototype.iy = function () {
        return this.xAxis.ou(this.cw.ca, this.cw.b9, this.getEffectiveViewport1(this.cw));
    };
    RangeColumnSeries.prototype.aax = function (a, b) {
        _super.prototype.aax.call(this, a, b);
        var c = typeCast(RangeColumnSeriesView.$, b);
        var d = a.h;
        var e = b.ca;
        var f = b.b9;
        var g = this.getEffectiveViewport1(b);
        var h = this.xAxis.ou(e, f, g);
        if (isNaN_(h) || isInfinity(h)) {
            c.dl.count = 0;
            return;
        }
        this.zc.a2(this, this.zw(), runOn(this, this.yw), this.z5(b), this.z6(b));
        this.zc.r = this.acd;
        this.zc.s = this.ace;
        this.zc.k = this.acd;
        this.zc.l = this.ace;
        var i = false;
        var j = this.zc.b;
        if (j != null) {
            i = true;
        }
        var k = this.xAxis.dm;
        var l = this.lowColumn.count;
        var m = this.xAxis;
        var n = new ScalerParams(0, e, f, this.xAxis.df, g);
        var o = 0;
        for (var p = 0; p < d.count; ++p) {
            var q = d._inner[p][0] - 0.5 * h;
            var r = Math.min(d._inner[p][1], d._inner[p][2]);
            var s = Math.max(d._inner[p][1], d._inner[p][2]);
            var t = Math.abs(s - r);
            if (isInfinity(t) || isNaN_(t)) {
                continue;
            }
            var u = c.dl.item(o);
            o++;
            u.width = h;
            u.height = t;
            var v = this.zc.aw(l, p)[0];
            if (k && a.o != null && p >= 0 && p < a.o.count) {
                v = truncate(Math.round(a.o._inner[p]));
            }
            if (i) {
                this.aat(d, p, l, m, n, b.t, v);
            }
            this.zc.ad(u, false, false, false, false);
            u.ap = this.zc.k;
            u.aq = this.zc.l;
            c.dr(u, q, r);
        }
        c.dl.count = o;
        b.dg(a);
    };
    RangeColumnSeries.prototype.qa = function (a, b, c) {
        this.aap(a, b, c, this.y3, 1);
    };
    RangeColumnSeries.prototype.ak = function (a, b) {
        var c = new List$1(ChartSelection.$, 0);
        this.qa(a, c, b);
        return c.toArray();
    };
    Object.defineProperty(RangeColumnSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.z0;
        },
        enumerable: false,
        configurable: true
    });
    RangeColumnSeries.$t = markType(RangeColumnSeries, 'RangeColumnSeries', HorizontalRangeCategorySeries.$);
    RangeColumnSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RangeColumnSeries, 'raisePropertyChanged', ['RadiusX:acd:ach', [1, 0], 'RadiusY:ace:aci', [1, 0]]);
    return RangeColumnSeries;
}(HorizontalRangeCategorySeries));
export { RangeColumnSeries };
/**
 * @hidden
 */
var RangeColumnSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(RangeColumnSeriesView, _super);
    function RangeColumnSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.dk = null;
        _this.dl = null;
        _this.dm = null;
        _this.ds = new Rectangle();
        _this.dk = a;
        _this.dl = ((function () {
            var $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(_this, _this.dt);
            $ret.activate = runOn(_this, _this.dn);
            $ret.disactivate = runOn(_this, _this.dq);
            $ret.destroy = runOn(_this, _this.dp);
            return $ret;
        })());
        return _this;
    }
    RangeColumnSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        this.dm = new List$1(Rectangle.$, 0);
        if (!this.t) {
            this.dk.xk = Defaults.c;
            this.dk.jt = Defaults.i;
        }
    };
    RangeColumnSeriesView.prototype.dt = function () {
        var a = new Rectangle();
        this.dm.add(a);
        a._visibility = 1;
        return a;
    };
    RangeColumnSeriesView.prototype.dn = function (a) {
        a._visibility = 0;
    };
    RangeColumnSeriesView.prototype.dq = function (a) {
        a._visibility = 1;
    };
    RangeColumnSeriesView.prototype.dp = function (a) {
        this.dm.remove(a);
    };
    RangeColumnSeriesView.prototype.dr = function (a, b, c) {
        if (!this.isDirty) {
            this.a2();
        }
        a.o = c;
        a.n = b;
    };
    RangeColumnSeriesView.prototype.ak = function (a) {
        return this.dm._inner[a];
    };
    RangeColumnSeriesView.prototype.aj = function (a) {
        var b = this.dm._inner[a];
        this.ds._visibility = b._visibility;
        this.ds.n = b.n;
        this.ds.o = b.o;
        this.ds.width = b.width;
        this.ds.height = b.height;
        var c = this.b4(a);
        this.ds._fill = c;
        this.ds._stroke = c;
        this.ds.ad = this.f.ig + 3;
        return this.ds;
    };
    RangeColumnSeriesView.prototype.bj = function (a, b) {
        _super.prototype.bj.call(this, a, b);
        if (a.d) {
            for (var c = 0; c < this.dm.count; c++) {
                var d = this.ai(c, b);
                this.br(d, c, b);
                a.w(d);
            }
        }
    };
    RangeColumnSeriesView.prototype.ax = function (a) {
        var e_1, _a, e_2, _b;
        _super.prototype.ax.call(this, a);
        var b = 0;
        var c = new List$1(Rectangle.$, 0);
        try {
            for (var _c = __values(fromEnum(this.dl.a)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                c.add(d);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        c.aa(function (e, f) {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                this.f.bc.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        b++;
    };
    RangeColumnSeriesView.$t = markType(RangeColumnSeriesView, 'RangeColumnSeriesView', RangeCategorySeriesView.$);
    return RangeColumnSeriesView;
}(RangeCategorySeriesView));
export { RangeColumnSeriesView };
